module ExcelFunctions
end

# Support functions
require_relative 'excel_functions/number_argument'
require_relative 'excel_functions/string_argument'
require_relative 'excel_functions/reset'

# Constants
require_relative 'excel_functions/pi'

# Comparators
require_relative 'excel_functions/excel_equal'
require_relative 'excel_functions/less_than'
require_relative 'excel_functions/more_than'
require_relative 'excel_functions/less_than_or_equal'
require_relative 'excel_functions/more_than_or_equal'
require_relative 'excel_functions/not_equal'

require_relative 'excel_functions/excel_if'
require_relative 'excel_functions/iferror'

# Basic arithmetic
require_relative 'excel_functions/add'
require_relative 'excel_functions/subtract'
require_relative 'excel_functions/multiply'
require_relative 'excel_functions/divide'
require_relative 'excel_functions/power'
require_relative 'excel_functions/negative'

# More advanced arithmetic
require_relative 'excel_functions/abs'
require_relative 'excel_functions/and'
require_relative 'excel_functions/mod'
require_relative 'excel_functions/not'

# Array arithmetic
require_relative 'excel_functions/sum'
require_relative 'excel_functions/average'
require_relative 'excel_functions/max'
require_relative 'excel_functions/min'
require_relative 'excel_functions/subtotal'
require_relative 'excel_functions/count'
require_relative 'excel_functions/counta'
require_relative 'excel_functions/sumif'
require_relative 'excel_functions/sumifs'
require_relative 'excel_functions/sumproduct'

# Lookup functions
require_relative 'excel_functions/index'
require_relative 'excel_functions/excel_match'
require_relative 'excel_functions/vlookup'
require_relative 'excel_functions/choose'
require_relative 'excel_functions/large'

# Financial functions
require_relative 'excel_functions/pmt'

# Geometry functions
require_relative 'excel_functions/cosh'

# String functions
require_relative 'excel_functions/string_join'
require_relative 'excel_functions/find'
require_relative 'excel_functions/left'
require_relative 'excel_functions/right'

# Rounding functions
require_relative 'excel_functions/round'
require_relative 'excel_functions/roundup'
require_relative 'excel_functions/rounddown'
require_relative 'excel_functions/int'

# Other functions

require_relative 'excel_functions/cell'

require_relative 'excel_functions/trim'

require_relative 'excel_functions/mid'

require_relative 'excel_functions/pv'

require_relative 'excel_functions/text'

require_relative 'excel_functions/hlookup'

require_relative 'excel_functions/log'

require_relative 'excel_functions/mmult'

require_relative 'excel_functions/rank'

require_relative 'excel_functions/isnumber'

require_relative 'excel_functions/len'

require_relative 'excel_functions/substitute'

require_relative 'excel_functions/lower'

require_relative 'excel_functions/exp'

require_relative 'excel_functions/isblank'

require_relative 'excel_functions/averageifs'

require_relative 'excel_functions/forecast'

require_relative 'excel_functions/ensure_is_number'

require_relative 'excel_functions/value'

require_relative 'excel_functions/ln'

require_relative 'excel_functions/iserr'

require_relative 'excel_functions/npv'

require_relative 'excel_functions/iserror'

require_relative 'excel_functions/char'

require_relative 'excel_functions/address'

require_relative 'excel_functions/number_or_zero'

require_relative 'excel_functions/countif'

require_relative 'excel_functions/hyperlink'

require_relative 'excel_functions/na'

require_relative 'excel_functions/or'

require_relative 'excel_functions/scurve'

require_relative 'excel_functions/floor'

require_relative 'excel_functions/sqrt'

require_relative 'excel_functions/product'

require_relative 'excel_functions/countifs'

require_relative 'excel_functions/replace'

require_relative 'excel_functions/rate'

require_relative 'excel_functions/ceiling'

require_relative 'excel_functions/mround'
