# -*- encoding: utf-8 -*-
# stub: excel_to_code 0.3.19 ruby src

Gem::Specification.new do |s|
  s.name = "excel_to_code".freeze
  s.version = "0.3.19"

  s.required_rubygems_version = Gem::Requirement.new(">= 0".freeze) if s.respond_to? :required_rubygems_version=
  s.require_paths = ["src".freeze]
  s.authors = ["Thomas Counsell, Green on Black Ltd".freeze]
  s.date = "2019-01-08"
  s.description = "# Excel to Code\n\n[![Tests Passing](https://travis-ci.org/tamc/excel_to_code.svg?branch=master)](https://travis-ci.org/tamc/excel_to_code)\n\nexcel_to_c - roughly translate some Excel files into C.\n\nexcel_to_ruby - roughly translate some Excel files into Ruby.\n\nThis allows spreadsheets to be:\n\n1. Embedded in other programs, such as web servers, or optimisers\n2. Without depending on any Microsoft code\n\nFor example, running [these commands](examples/simple/compile.sh) turns [this spreadsheet](examples/simple/simple.xlsx) into [this Ruby code](examples/simple/ruby/simple.rb) or [this C code](examples/simple/c/simple.c).\n\n# Install\n\nRequires Ruby. Install by:\n\n    gem install excel_to_code\n\n# Run\n\nTo just have a go:\n\n\texcel_to_c <excel_file_name>\n\nThis will produce a file called excelspreadsheet.c\n\nFor a more complex spreadsheet:\n\t\n\texcel_to_c --compile --run-tests --settable <name of input worksheet> --prune-except <name of output worksheet> <excel file name> \n\t\nSee the full list of options:\n\n\texcel_to_c --help\n\n# Gotchas, limitations and bugs\n\n0. No custom functions, no macros for generating results\n1. Results are cached. So you must call reset(), then set values, then read values.\n2. It must be possible to replace INDIRECT and OFFSET formula with standard references at compile time (e.g., INDIRECT(\"A\"&\"1\") is fine, INDIRECT(userInput&\"3\") is not.\n3. Doesn't implement all functions. [See which functions are implemented](docs/Which_functions_are_implemented.md).\n4. Doesn't implement references that involve range unions and lists (but does implement standard ranges)\n5. Sometimes gives cells as being empty, when excel would give the cell as having a numeric value of zero\n6. The generated C version does not multithread and will give bad results if you try.\n7. The generated code uses floating point, rather than fully precise arithmetic, so results can differ slightly.\n8. The generated code uses the sprintf approach to rounding (even-odd) rather than excel's 0.5 rounds away from zero.\n9. Ranges like this: Sheet1!A10:Sheet1!B20 and 3D ranges don't work.\n\nReport bugs: <https://github.com/tamc/excel_to_code/issues>\n\n# Changelog\n\nSee [Changes](CHANGES.md).\n\n# License\n\nSee [License](LICENSE.md)\n\n# Hacking\n\nSource code: <https://github.com/tamc/excel_to_code>\n\nDocumentation:\n\n* [Installing from source](docs/installing_from_source.md)\n* [Structure of this project](docs/structure_of_this_project.md)\n* [How does the calculation work](docs/how_does_the_calculation_work.md)\n* [How to fix parsing errors](docs/How_to_fix_parsing_errors.md)\n* [How to implement a new Excel function](docs/How_to_add_a_missing_function.md)\n\nSome notes on how Excel works under the hood:\n\n* [The Excel file structure](docs/implementation/excel_file_structure.md)\n* [Relationships](docs/implementation/relationships.md)\n* [Workbooks](docs/implementation/workbook.md)\n* [Worksheets](docs/implementation/worksheets.md)\n* [Cells](docs/implementation/cell.md)\n* [Tables](docs/implementation/tables.md)\n* [Shared Strings](docs/implementation/shared_strings.md)\n* [Array formulae](docs/implementation/array_formulae.md)\n\n".freeze
  s.email = "tamc@greenonblack.com".freeze
  s.executables = ["excel_to_c".freeze, "excel_to_ruby".freeze]
  s.files = ["bin/excel_to_c".freeze, "bin/excel_to_ruby".freeze]
  s.homepage = "http://github.com/tamc/excel_to_code".freeze
  s.licenses = ["MIT".freeze]
  s.required_ruby_version = Gem::Requirement.new(">= 2.3.0".freeze)
  s.rubygems_version = "3.2.22".freeze
  s.summary = "Convert many .xlsx and .xlsm files into equivalent Ruby or C code that can be executed without Excel".freeze

  s.installed_by_version = "3.2.22" if s.respond_to? :installed_by_version

  if s.respond_to? :specification_version then
    s.specification_version = 4
  end

  if s.respond_to? :add_runtime_dependency then
    s.add_runtime_dependency(%q<rubypeg>.freeze, ["~> 0", ">= 0.0.4"])
    s.add_runtime_dependency(%q<rspec>.freeze, ["~> 3.7"])
    s.add_runtime_dependency(%q<ffi>.freeze, ["~> 1.9", ">= 1.9.18"])
    s.add_runtime_dependency(%q<ox>.freeze, ["~> 2.8", ">= 2.8.2"])
    s.add_runtime_dependency(%q<minitest>.freeze, ["~> 5.11", ">= 5.11.1"])
    s.add_development_dependency(%q<rake>.freeze, ["~> 12"])
  else
    s.add_dependency(%q<rubypeg>.freeze, ["~> 0", ">= 0.0.4"])
    s.add_dependency(%q<rspec>.freeze, ["~> 3.7"])
    s.add_dependency(%q<ffi>.freeze, ["~> 1.9", ">= 1.9.18"])
    s.add_dependency(%q<ox>.freeze, ["~> 2.8", ">= 2.8.2"])
    s.add_dependency(%q<minitest>.freeze, ["~> 5.11", ">= 5.11.1"])
    s.add_dependency(%q<rake>.freeze, ["~> 12"])
  end
end
